//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/csspeech/license201809 for the full license information.
//
// azac_api_c_property_bag.h: Public API declarations for Property Bag related C methods
//

#pragma once
#include <azac_api_c_common.h>

AZAC_API property_bag_create(AZACPROPERTYBAGHANDLE* hpropbag);
AZAC_API_(bool) property_bag_is_valid(AZACPROPERTYBAGHANDLE hpropbag);
AZAC_API property_bag_set_string(AZACPROPERTYBAGHANDLE hpropbag, int id, const char* name, const char* value);
AZAC_API__(const char*) property_bag_get_string(AZACPROPERTYBAGHANDLE hpropbag, int id, const char* name, const char* defaultValue);
AZAC_API property_bag_free_string(const char* value);
AZAC_API property_bag_release(AZACPROPERTYBAGHANDLE hpropbag);
AZAC_API property_bag_copy(AZACPROPERTYBAGHANDLE hfrom, AZACPROPERTYBAGHANDLE hto);
