//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once

#include <azac_api_c_common.h>

AZAC_API__(uint8_t*) ai_core_allocate_buffer(size_t size);
AZAC_API_(void) ai_core_free_buffer(const uint8_t* ptr);

typedef void(*AZAC_REFCOUNT_CLEAR_FN)(void *);

AZAC_API vision_refcount_create(void * context, AZAC_REFCOUNT_CLEAR_FN destructor, AZAC_HANDLE* handle);
AZAC_API vision_refcount_add_ref(AZAC_HANDLE refCountHandle, AZAC_HANDLE * handle);
AZAC_API vision_refcount_release(AZAC_HANDLE refCountHandle);
