//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once
#include <azac_api_cxx_details_property_collection.h>
#include <vision_api_cxx_common.h>

namespace Azure {
namespace AI {
namespace Vision {
namespace Service {

/// <summary>
/// Enumeration of vision service options
/// </summary>
enum class VisionServiceOption
{
    /// <summary>
    /// Endpoint URL of the service
    /// </summary>
    Endpoint = 0,

    /// <summary>
    /// URL of the proxy server to use
    /// </summary>
    HttpProxy = 1,

    /// <summary>
    /// User name for the proxy server
    /// </summary>
    HttpProxyUserName = 2,

    /// <summary>
    /// Password for the proxy server
    /// </summary>
    HttpProxyPassword = 3

    // TODO: TFS#3664448 - Vision: What VisionServiceOption's should we have?
};

} } } } // Azure::AI::Vision::Service

PRIVATE_PROPERTY_COLLECTION_STATICS(Azure::AI::Vision::Service::VisionServiceOption, "service")
