//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once
#include <azac_api_cxx_details_property_collection.h>
#include <vision_api_cxx_common.h>
#include <vision_api_cxx_session_result_property.h>

namespace Azure {
namespace AI {
namespace Vision {
namespace Core {
namespace Session {

/// <summary>
/// Represents the collection of properties on a given SessionResultResult
/// </summary>
class SessionResultProperties : private AI::Core::Details::PropertyCollectionBase<SessionResultProperty>
{
private:
    template<typename Target>
    using ProtectedAccess = Azure::AI::Core::Details::ProtectedAccess<Target>;
    using PropertyCollection = AI::Core::Details::PropertyCollectionBase<SessionResultProperty>;

public:
    using PropertyCollection::Set;
    using PropertyCollection::Get;

protected:
    /*! \cond PROTECTED */
    SessionResultProperties(AZAC_HANDLE handle) : PropertyCollection(handle) {}
    explicit operator AZAC_HANDLE() { return ProtectedAccess<PropertyCollection>::HandleFromPtr(this); }
    /*! \endcond */
};

} } } } } // Azure::AI::Vision::Core::Session
