//
// Copyright (c) Microsoft. All rights reserved.
// See https://aka.ms/azai/vision/license for the full license information.
//

#pragma once
#include <vision_api_cxx_common.h>

namespace Azure {
namespace AI {
namespace Vision {
namespace Core {
namespace Session {

/// <summary>
/// Session Result Properties.
///
/// Not use by ImageAnalyzer.
/// </summary>
enum class SessionResultProperty
{
    /// <summary>
    /// The raw JSON result string from the service
    ///
    /// Not use by ImageAnalyzer.
    /// </summary>
    Json = 0

    // TODO: TFS#3664439 Vision Media APIs - What SessionResultProperty do we want?
};

} } } } } // Azure::AI::Vision::Core::Session

PRIVATE_PROPERTY_COLLECTION_STATICS(Azure::AI::Vision::Core::Session::SessionResultProperty, "session.result")
